#include <windows.h>
#include "tinygraphics.h"

#define APP_NAME TEXT("Of[V낤")

HDC hMemDC;
HBITMAP hBitmap;

void pset(int x,int y,unsigned char r,unsigned char g,unsigned char b){
	HPEN hPen;
	HGDIOBJ hObj;

	hPen = CreatePen(PS_SOLID,1,RGB(r,g,b));
	hObj = SelectObject(hMemDC,hPen);
	Rectangle(hMemDC,2*x,2*y,2*(x+1),2*(y+1));
	SelectObject(hMemDC,hObj);
	DeleteObject(hPen);
}

LRESULT CALLBACK WindowProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){
	HDC hdc;
	PAINTSTRUCT ps;

	switch(uMsg){
	case WM_DESTROY:
		/* foCXƃrbg}bv폜 */
		DeleteDC(hMemDC);
		DeleteObject(hBitmap);

		PostQuitMessage(0);
		return 0;

	case WM_CREATE:
		hdc = GetDC(hWnd);
		/* foCXƃrbg}bv쐬 */
		hMemDC = CreateCompatibleDC(hdc);
		hBitmap  = CreateCompatibleBitmap(hdc,XSIZE*2,YSIZE*2);
		ReleaseDC(hWnd,hdc);

		SelectObject(hMemDC,hBitmap);
		SelectObject(hMemDC,GetStockObject(WHITE_PEN));
		SelectObject(hMemDC,GetStockObject(WHITE_BRUSH));

		/* foCXɒ`` */
		Rectangle(hMemDC,0,0,XSIZE*2,YSIZE*2);

		SelectObject(hMemDC,GetStockObject(BLACK_BRUSH));
		
		main();

		return 0;

	case WM_MOUSEMOVE:
		/* foCXɓ_` */
		/*
		if(GetKeyState(VK_LBUTTON) <0){
			int x=LOWORD(lParam);
			int y=HIWORD(lParam);
			Ellipse(hMemDC,x-2,y-2,x+2,y+2);
			InvalidateRect(hWnd,NULL,FALSE);
		}
		*/
		return 0;

	case WM_PAINT:
		hdc = BeginPaint(hWnd,&ps);
		BitBlt(hdc,0,0,XSIZE*2,YSIZE*2,hMemDC,0,0,SRCCOPY);
		EndPaint(hWnd,&ps);
		return 0;
	}
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,PSTR lpCmdLine,int nCmdShow){
	WNDCLASS wc;
	MSG msg;

	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WindowProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(NULL,IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground = GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName = NULL;
	wc.lpszClassName = APP_NAME;
	
	if(!RegisterClass(&wc)){
		return 0;
	}

	if(CreateWindow(
		APP_NAME,TEXT(__FILE__),
		(WS_OVERLAPPEDWINDOW ^ WS_THICKFRAME ^ WS_MAXIMIZEBOX) | WS_VISIBLE,
		CW_USEDEFAULT,CW_USEDEFAULT,
		(XSIZE*2)+4,(YSIZE*2)+30,
		NULL,NULL,hInstance,NULL) == NULL){
		return 0;
	}

	while(GetMessage(&msg,NULL,0,0) > 0){
		DispatchMessage(&msg);
	}

	return msg.wParam;
}

